;debug mode = slow
;messy code = smr597

Include "fps.bb"

AppTitle "dot3 normalmapping"

Graphics3D 1024, 768, 32, 1
SetBuffer BackBuffer()
ClearTextureFilters()

Type Dot3Light
	Field ent
	Field mul#
	Field Range#
	Field typ
End Type

Global bumpvec = CreatePivot()
Global r2#, g2#, b2#

;---------------------------------------------------
; dot3 specular...
;fxcam=CreateCamera()
;CameraClsColor fxcam,127,127,0

;Lbox=LoadLightBox("LightCube\normalize","png")

;Ref=LoadTexture( "LightCube\lightBl.png",1)
;TextureBlend Ref,1

;ambientlight
Global AR#=60,AG#=60,AB#=80
AmbientLight AR#,AG#,AB#
ambientTex = CreateTexture(16,16)
TextureBlend ambientTex, 3
SetBuffer TextureBuffer(ambientTex)
ClsColor AR#,AG#,AB#
Cls
SetBuffer BackBuffer()


;---------------------------------------------------
;Camera
center=CreatePivot()
Cam = CreateCamera()
CameraClsColor cam,100,100,100
CameraRange cam,.1,10000
;CameraClsColor cam,AR#,AG#,AB#
PositionEntity cam,-3.5,2.5,0
PointEntity cam,center

;---------------------------------------------------
;Light
LiPiv=CreatePivot();:PositionEntity lipiv,-3,0,0
Light = Dot3_CreateLight(2,LiPiv)
RotateEntity Light,45,-45,0
Dot3_LightRange(Light,1);light range if 0 then infinite
Dot3_LightIntensity(Light,1)

;R#=255:G#=128:B#=0
;R#=255:G#=255:B#=255
R#=255:G#=0:B#=0
ColorTex=CreateTexture(32,32)
SetBuffer TextureBuffer( ColorTex )
ClsColor R,G,B
Cls
SetBuffer BackBuffer()
TextureBlend ColorTex,2
LightColor light,R,G,B

; REFTEX
;Reftex=CreateTexture( 32,32, 128+256)
;SetCubeMode Reftex,1
;TextureBlend Reftex,2

;Light blob
blob = CreateSphere(8, Light)
ScaleEntity blob, .1, .1, .1
EntityColor blob,R,G,B
EntityFX blob, 1


;---------------------------------------------------
;textures
Tex = LoadTexture("blue.jpg"):ScaleTexture Tex,.5,.5
TextureBlend tex, 2
Bump = LoadTexture("blue_n.jpg"):ScaleTexture Bump,.5,.5
TextureBlend Bump, 4

Tex2 = LoadTexture("encyl.jpg"):ScaleTexture Tex2,.5,.5
TextureBlend tex2, 2
Bump2 = LoadTexture("encyl_n.jpg"):ScaleTexture Bump2,.5,.5
TextureBlend Bump2, 4	
Add2=	LoadTexture("encyl_a.jpg")ScaleTexture Add2,.5,.5	
TextureBlend Add2,3
			
Tex3 = LoadTexture("rockwall.jpg"):ScaleTexture Tex3,.2,.2
TextureBlend tex3, 2
Bump3 = LoadTexture("rockwall_n.jpg"):ScaleTexture Bump3,.2,.2
TextureBlend Bump3, 4

;---------------------------------------------------
;room
room = LoadMesh("cube.3ds"):s#=10
ScaleMesh room, s, -s, -s
PositionMesh room,0,8,0
FlipMesh room
EntityFX room, 3
EntityTexture room, Bump2,0,0
EntityTexture room, ColorTex,0,1
EntityTexture room, ambientTex,0,2
EntityTexture room, tex2,0,3
EntityTexture room, add2,0,4

;ground
ground = LoadMesh("cube.3ds"):s#=10
ScaleMesh ground, s, .1, s
PositionMesh ground,0,-1.2,0
EntityFX ground, 3
EntityTexture ground, Bump3,0,0
EntityTexture ground, ColorTex,0,1
EntityTexture ground, ambientTex,0,2
EntityTexture ground, tex3,0,3

;Obj4_S=CopyMesh(ground,ground)
;EntityFX Obj4_S,1
;EntityColor Obj4_S,255,255,255
;EntityBlend Obj4_S,3

;EntityTexture Obj4_S, Reftex,0,0
;EntityTexture Obj4_S, Bump3,0,1
;EntityTexture Obj4_S,ColorTex,0,2
;EntityTexture Obj4_S,tex_s,0,3

;Objects
Obj = CreateSphere(16):PositionEntity Obj,0,0,-3
EntityFX Obj, 3
EntityTexture Obj, Bump,0,0
EntityTexture Obj, ColorTex,0,1
EntityTexture Obj, ambientTex,0,2
EntityTexture Obj, tex,0,3


Obj2=CopyMesh(obj):PositionEntity Obj2,3,0,0
EntityFX Obj2, 3
EntityTexture Obj2, Bump,0,0
EntityTexture Obj2, ColorTex,0,1
EntityTexture Obj2, ambientTex,0,2
EntityTexture Obj2, tex,0,3

Obj3=CopyMesh(obj):PositionEntity Obj3,-3,0,0
EntityFX Obj3, 3
EntityTexture Obj3, Bump,0,0
EntityTexture Obj3, ColorTex,0,1
EntityTexture Obj3, ambientTex,0,2
EntityTexture Obj3, tex,0,3

Obj4=CopyMesh(obj):PositionEntity Obj4,0,0,3
EntityFX Obj4, 3
EntityTexture Obj4, Bump,0,0
EntityTexture Obj4, ColorTex,0,1
EntityTexture Obj4, ambientTex,0,2
EntityTexture Obj4, tex,0,3



;model
Htex = LoadTexture("devil.jpg")
TextureBlend htex, 2
HBump = LoadTexture("devil_n.jpg")
TextureBlend hBump, 4

model = LoadMesh("devil.3ds")
ScaleEntity model,.042,.042,.042;2,2,2
PositionEntity model,0,-1,0
EntityFX model, 3
EntityTexture model, hBump,0,0
EntityTexture model, ColorTex,0,1
EntityTexture model, ambientTex,0,2
EntityTexture model, htex,0,3


;main loop
Const FPS=60
framePeriod = 1000 / FPS
frameTime = MilliSecs () - framePeriod


While Not KeyHit(1)
   ;PositionEntity Light, (MouseY()-768/2)/-100.0,1.5,-(MouseX()-1024/2)/100.0	
	FreeLook(cam,.1)	

	PositionEntity Light, Cos(MilliSecs() * .1) * 2, 1, Sin(MilliSecs() * .1) * 2
	;PositionEntity Light, 2,1,2
	PointEntity Light, lipiv
	TurnEntity model,0,-.5,0

	;render normal maps
	MeshBumpNormals(Obj)
	MeshBumpNormals(Obj2)
	MeshBumpNormals(Obj3)
	MeshBumpNormals(Obj4)
	MeshBumpNormals(model)
	MeshBumpNormals(room)
	MeshBumpNormals(ground)	
	
	;render dot3 specularity
	;RenderLight (Obj4_S, reftex, light, fxcam, cam, Lbox, 0, 1, 20, .9, Ref)

						
	UpdateWorld
	RenderWorld

	
	
	Color 255,255,0
	Text 10,10,fps(50)

	Flip 0
Wend
End

Function Dot3_CreateLight(typ = 1,parent=0)
d3l.Dot3Light = New Dot3Light
d3l\ent = CreateLight(typ,parent)
d3l\typ = typ
d3l\mul# = 1
Return d3l\ent
End Function

Function Dot3_LightRange(ent,range#)
	For d3l.dot3light = Each dot3light
		If d3l\ent = ent
			If Lower$(EntityClass(d3l\ent))="light"
				If range=0 Then
				Else
				LightRange d3l\ent,range
				End If
				d3l\range# = range
				Return
			End If
		End If
	Next	
End Function

Function Dot3_LightIntensity(ent,intens#)
	For d3l.dot3light = Each dot3light
		If d3l\ent = ent
			d3l\mul = intens
			If Lower$(EntityClass(d3l\ent))="light"
				LightColor d3l\ent,d3l\mul*255.0,d3l\mul*255.0,d3l\mul*255.0
			End If			
			Return
		End If
	Next
End Function

Function MeshBumpNormals(mesh)
cnt_surf = CountSurfaces(mesh)
For s = 1 To cnt_surf
	surf = GetSurface(mesh,s)
	cnt_vert = CountVertices(surf)
	For v = 0 To cnt_vert - 1
		r2# = 0
		g2# = 0
		b2# = 0
		For d3l.Dot3Light = Each Dot3Light
			If d3l\typ = 1 Then
				
				TFormNormal VertexNX(surf, v), VertexNY(surf, v), VertexNZ(surf, v), mesh, 0
				r# = TFormedX()
				g# = TFormedY()
				b# = TFormedZ()
				
				TFormVector 0, 0, -1, d3l\ent, 0
				nx# = TFormedX()
				ny# = TFormedY()
				nz# = TFormedZ()

				
				;range/distance hack
				;Distance#=EntityDistance(d3l\ent,mesh)
				;If d3l\range=0 Then 
				;	d3range#=1
				;Else
				;	d3range#=((Distance#/(d3l\range#*2))+((d3l\range#/Distance#)*.2))
				;EndIf
				
				;d# = Sqr(r# * r# + g# * g# + b# * b#)*d3range#
				;r# = r# / d#
				;g# = g# / d#
				;b# = b# / d#
								

			ElseIf d3l\typ = 2 Then
			
				TFormPoint VertexX(surf, v), VertexY(surf, v), VertexZ(surf, v), mesh, 0
				r# = TFormedX() - EntityX(d3l\ent, True)
				g# = TFormedY() - EntityY(d3l\ent, True)
				b# = TFormedZ() - EntityZ(d3l\ent, True)
				
				TFormNormal VertexNX(surf, v), VertexNY(surf, v),VertexNZ(surf, v), mesh, 0
				nx# = -TFormedX()
				ny# = -TFormedY()
				nz# = -TFormedZ()		


				;range/distance hack
				Distance#=EntityDistance(d3l\ent,mesh)
				If d3l\range=0 Then 
					d3range#=1
				Else
					d3range#=((Distance#/(d3l\range#*2))+((d3l\range#/Distance#)*.2))
				EndIf
				
				d# = Sqr(r# * r# + g# * g# + b# * b#)*d3range#
				r# = r# / d#
				g# = g# / d#
				b# = b# / d#

				
			End If
			
			dot# = r# * nx# + g# * ny# + b# * nz#
			If dot# < 0 Then dot# = 0
						
			;a bit from Raitsun's code			
			PositionEntity bumpvec,TFormedX(),TFormedY(),TFormedZ(),1
			AlignToVector bumpvec,TFormedX(),TFormedY(),TFormedZ(),3,1
			RotateEntity bumpvec,EntityPitch(bumpvec,1),EntityYaw(bumpvec,1),0,1
			
			TFormNormal r,g,b,0,bumpvec	

			; -----------------------------------> the magic happens here
			;new function
			If d3l\typ = 1 Then 							
				r# = ((1+ TFormedX()* dot# ) * 128) * d3l\mul#
				g# = ((1+ TFormedY()* dot# ) * 128) * d3l\mul#
				b# = ((1+ TFormedZ()* dot# ) * 128) * d3l\mul#	
			ElseIf d3l\typ = 2 Then	
				r# = ((1+ TFormedX()* dot# ) * 128) * d3l\mul#
				g# = ((1+ TFormedY()* dot# ) * 128) * d3l\mul#
				b# = ((1- TFormedZ()* dot# ) * 128) * d3l\mul#
			End If
			;old function	
			;	r# = (1- r# * dot#) * 128 * d3l\mul#
			;	g# = (1- g# * dot#) * 128 * d3l\mul#
			;	b# = (1+ b# * dot#) * 128 * d3l\mul#	

					
			If r# < 0 Then r# = 0
			If g# < 0 Then g# = 0
			If b# < 0 Then b# = 0
			
			r2# = r2# + r#
			g2# = g2# + g#
			b2# = b2# + b#			
			;r2# = r#
			;g2# = g#
			;b2# = b#						

			
		Next
		
		VertexColor surf, v, r2#, g2#, b2#
	Next
Next

End Function

;RenderLight
Function RenderLight (ent, Rtex, light, dot3cam, cam, mesh, Intencity#=1, Mode=0,size#=10, IntencitySpr#=1, libl=0)
Local BlicSpr

cnt_surf = CountSurfaces(ent)
For s = 1 To cnt_surf
	surf = GetSurface(ent,s)
	cnt_vert = CountVertices(surf)
	For v = 0 To cnt_vert - 1
		;TFormNormal 0,0,1,light,0
		TFormNormal VertexNX(surf, v), VertexNY(surf, v),VertexNZ(surf, v), light, 0
		;nx# = -TFormedX()
		;ny# = -TFormedY()
		;nz# = -TFormedZ()
		TFormPoint VertexX(surf, v), VertexY(surf, v), VertexZ(surf, v),light, 0
		r# = TFormedX() - EntityX(light, True)
		g# = TFormedY() - EntityY(light, True)
		b# = TFormedZ() - EntityZ(light, True)
				


				
				d# = Sqr(r# * r# + g# * g# + b# * b#)
				r# = r# / d#
				g# = g# / d#
				b# = b# / d#

					
		CameraViewport dot3cam, 0,0,TextureWidth(Rtex), TextureHeight(Rtex)
		CameraProjMode dot3cam,1
		CameraProjMode cam,0
		PositionEntity dot3cam,65535,65535,65535

		ScaleEntity mesh,10,10,10
		EntityFX mesh,1
		EntityColor mesh,255*IntencitySpr#,255*IntencitySpr#,255*Intencity#
		PositionEntity mesh,65535,65535,65535
		AlignToVector mesh, TFormedX(), TFormedY(), TFormedZ(),0

		;a bit from Raitsun's code			
		;PositionEntity bumpvec,TFormedX(),TFormedY(),TFormedZ(),1
		;AlignToVector bumpvec,TFormedX(),TFormedY(),TFormedZ(),3,1
		;RotateEntity bumpvec,EntityPitch(bumpvec,1),EntityYaw(bumpvec,1),0,1		
		;TFormNormal r,g,b,0,bumpvec
				
	Next
Next		
		


	ShowEntity mesh

		If Mode=1
			BlicSpr=CreateSprite()
			If libl EntityTexture BlicSpr,libl
			ScaleSprite BlicSpr,size#,size#
			SpriteViewMode BlicSpr,2
			EntityBlend BlicSpr,3
			EntityColor BlicSpr,255,255,255*IntencitySpr#
			EntityFX BlicSpr,17
			PositionEntity BlicSpr,65535,65535,65535
			MoveEntity BlicSpr, -10*TFormedX(), -10*TFormedY(), -10*TFormedZ()
			PointEntity BlicSpr, dot3cam
			EntityOrder BlicSpr,-1
		EndIf

tex_sz=TextureWidth(Rtex) 

SetCubeFace Rtex,0 
RotateEntity dot3cam,0,90,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex) 

SetCubeFace Rtex,1 
RotateEntity dot3cam,0,0,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex) 

SetCubeFace Rtex,2 
RotateEntity dot3cam,0,-90,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex) 

SetCubeFace Rtex,3 
RotateEntity dot3cam,0,180,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex) 

SetCubeFace Rtex,4 
RotateEntity dot3cam,-90,0,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex) 

SetCubeFace Rtex,5 
RotateEntity dot3cam,90,0,0 
RenderWorld 
CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Rtex)

	If Mode=1
		FreeEntity BlicSpr
	EndIf
	HideEntity mesh
	CameraProjMode cam,1
	CameraProjMode dot3cam,0
  
End Function

;LoadLightBox	
Function LoadLightBox( file$, ext$ )
	m=CreateMesh()
	;front face
	b=LoadBrush( file$+"_pz."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,1,1:AddVertex s,+1,+1,-1,0,1
	AddVertex s,+1,-1,-1,0,0:AddVertex s,-1,-1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3:
	FreeBrush b
	;right face
	b=LoadBrush( file$+"_nx."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,1,1:AddVertex s,+1,+1,+1,0,1
	AddVertex s,+1,-1,+1,0,0:AddVertex s,+1,-1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( file$+"_nz."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,1,1:AddVertex s,-1,+1,+1,0,1
	AddVertex s,-1,-1,+1,0,0:AddVertex s,+1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( file$+"_px."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,1,1:AddVertex s,-1,+1,-1,0,1
	AddVertex s,-1,-1,-1,0,0:AddVertex s,-1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( file$+"_ny."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,1,1:AddVertex s,+1,+1,+1,0,1
	AddVertex s,+1,+1,-1,0,0:AddVertex s,-1,+1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;bottom face	
	b=LoadBrush( file$+"_py."+ext$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,-1,-1,1,1:AddVertex s,+1,-1,-1,0,1
	AddVertex s,+1,-1,+1,0,0:AddVertex s,-1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	FlipMesh m
	EntityFX m,1
	Return m
End Function	

; Free look the camera
Global FreeLookXS#, FreeLookZS#, FreeLookRotXS#, FreeLookRotYS#
Function FreeLook(camera, sp# = .1)
	If KeyDown(42) Then sp=sp*10
	If sp# > 0 Then
		FreeLookXS# = (FreeLookXS# + ((KeyDown(32)) - (KeyDown(30))) * sp#) * .75
		FreeLookZS# = (FreeLookZS# + ((KeyDown(17) Or (MouseZSpeed()*10)) - (KeyDown(31) Or (MouseZSpeed()*10))) * sp#) * .75
		MoveEntity camera, FreeLookXS#, 0, FreeLookZS#
	EndIf
	FreeLookRotXS# = ((MouseXSpeed() - FreeLookRotXS#) * .2 + FreeLookRotXS#) * .9
	FreeLookRotYS# = ((MouseYSpeed() - FreeLookRotYS#) * .2 + FreeLookRotYS#) * .9
	If EntityPitch(camera) + FreeLookRotYS# < -89 pitch# = -89 ElseIf EntityPitch(camera) + FreeLookRotYS# > 89 pitch# = 89 Else pitch# = EntityPitch(camera) + FreeLookRotYS#
	yaw# = -FreeLookRotXS# + EntityYaw(camera)
	RotateEntity camera, pitch#, yaw#, 0
	MoveMouse GraphicsWidth() / 2, GraphicsHeight() / 2
End Function